-- Author      : nbcaffeine
-- Create Date : 1/9/2013 

SJ = LibStub("AceAddon-3.0"):NewAddon("SJ", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")

local PREFIX = "[SecondJob]"
local VERSION="011913B3Alpha"
local myQuests={}
local debug=false
local completedQuests={}
local dailies={}
local weeklies={}
local goldenLotus={}
local augustCelestials={}
local shadoPan={}
local klaxxi={}
local shieldWall={}
--local dominanceOffensive={}
--local tillers={}
--local professions={}
local professions={}
--enchanting (sha crystal)
--alchemy (living steel)
--NOTE The professions code below only scans one at a time, the last one opened... yuck.
--JC (gem thingy)
--tailoring - big cloth thingy?
local sw1={} --Bilgewater Beach
local sw2a={} --Domination Point
local sw3a={} --Lion's Landing
local sw3b={} --Lion's Landing

local sw4a={} --Ruins of Ogudei a
local sw4b={} --Ruins of Ogudei b


sw2a[32146]="Hammer to Fall"
sw2a[32144]="Under Pressure"
sw2a[32142]="We Will Rock You"
sw2a[32143]="A Kind of Magic"
sw2a[32145]="Don't Lose Your Head"

sw3a[32148]="Attack! Move!"
sw3a[32152]="Siege Damage"
sw3a[32153]="Hero Killer"
sw3a[32149]="Resource Gathering"
sw3a[32150]="Supply Block"

sw3b[32148]="Attack! Move!"
sw3b[32151]="Tower Defense"
sw3b[32153]="Hero Killer"
sw3b[32149]="Resource Gathering"
sw3b[32150]="Supply Block"

sw4a[32121]="The Spirit Trap";
sw4a[32119]="It Is A Mystery";
sw4a[32347]="Eviction Notice";
sw4a[32346]="Oi Ain't Afraid o' No Ghosts!";
sw4a[32122]="Ogudei's Lieutenants";

sw4b[32121]="The Spirit Trap";
sw4b[32115]="Shackles of the Past";
sw4b[32347]="Eviction Notice";
sw4b[32346]="Oi Ain't Afraid o' No Ghosts!";
sw4b[32122]="Ogudei's Lieutenants";

--[[
sw4[32121]="The Spirit Trap";
sw4={32115="Shackles of the Past",32119="It Is A Mystery"}
sw4[32347]="Eviction Notice";
sw4[32346]="Oi Ain't Afraid o' No Ghosts!";
sw4[32122]="Ogudei's Lieutenants"
--]]

shieldWall[1]=sw2a
shieldWall[4]=sw4a
shieldWall[5]=sw4b
shieldWall[2]=sw3a
shieldWall[3]=sw3b

goldenLotus[30236]="Aetha"
goldenLotus[30297]="Baolai the Immolator"
goldenLotus[31136]="Behind Our Lines"
goldenLotus[30233]="Cracklefang"
goldenLotus[30296]="Gaohun the Soul-Severer"
goldenLotus[30239]="Lao-Fe the Slavebinder"
goldenLotus[30235]="Quid Pro Quo"
goldenLotus[30225]="The Ashweb Matriarch"
goldenLotus[30248]="The Butcher"
goldenLotus[30302]="The Imperion Threat"
goldenLotus[30249]="The Soul-Gatherer"
goldenLotus[30482]="Under the Setting Sun"
goldenLotus[30234]="Vicejaw"
goldenLotus[30251]="Vyraxxis, the Krik'thik Swarm-Lord"
goldenLotus[30227]="Wulon, the Granite Sentinel"

local augCele1={}
local augCele2={}
local augCele3={}
local augCele4={}


--augCele1[31378]="Challenge At The Temple of the Red Crane"
--2 stages, i think you can just check for stage 2:
--Stage 2:
augCele1[30725]="Ellia Ravenmane"
augCele1[30726]="Minh Do-Tan"
augCele1[30727]="Ellia Ravenmane: Rematch"
augCele1[30728]="Fat Long-Fat"
augCele1[30730]="Dextrous Izissha"
augCele1[30729]="Julia Bates"
augCele1[30731]="Kuo-Na Quillpaw"
augCele1[30732]="Ellia Ravenmane: Revenge"
augCele1[30733]="Tukka-Tuk"
augCele1[30734]="Huck Wheelbarrow"
augCele1[30735]="Mindel Sunspeaker"
augCele1[30736]="Yan Quillpaw"
augCele1[30737]="Fat Long-Fat: Rematch"
augCele1[30738]="Thelonius"
augCele1[30739]="Ellia Ravenmane: Redemption"
augCele1[30740]="Champion of Chi-Ji"

--augCele2[31376]="Attack At The Temple of the Jade Serpent"
--there is a final stage here, easy enough
augCele2[30067]="The Shadow of Doubt"

--augCele3[31382]="Defense At Niuzao Temple"
--Set A:
augCele3[30956]="The Siege Swells"
augCele3[30959]="The Big Guns"
augCele3[30957]="The Overwhelming Swarm"
augCele3[30958]="In Battle's Shadow"
--Set B:
augCele3[30954]="A Blade is a Blade"
augCele3[30952]="The Unending Siege"
augCele3[30953]="Fallen Sentinels"
augCele3[30955]="Paying Tribute"

--augCele4[31380]="Trial At The Temple of the White Tiger"
--Stage 1: one of 2:
augCele4[31517]="Contending With Bullies"
augCele4[31380]="The Torch of Strength"
--stage 2: one of 2:
augCele4[30907]="Round 4: The P.U.G."
augCele4[31380]="Round 4: Master Windfur"

augustCelestials[1]=augCele1
augustCelestials[2]=augCele2
augustCelestials[3]=augCele3
augustCelestials[4]=augCele4

--Shado-Pan
--there is a finale quest each group. YAY!
shadoPan[31049]="In Sprite Of Everything"
shadoPan[31204]="Target of Opportunity: Sra'thik Hivelord" 
shadoPan[31203]="Target of Opportunity: Sra'thik Swarmlord" 
shadoPan[31117]="Uruk!" 
shadoPan[31062]="When The Dead Speak" 
shadoPan[31061]="Riding the Storm" 
shadoPan[31120]="Cheng Bo" 

weeklies[32099]="Sha of Anger"
weeklies[32016]="Elder Charms"
dailies[31752]="Blingtron"
--dailies[31669]="Cabbages"

local questGroups={}
questGroups["Weeklies"]=weeklies
questGroups["Dailies"]=dailies
questGroups["GoldenLotus"]=goldenLotus
questGroups["AugustCelestials"]=augustCelestials
questGroups["ShadoPan"]=shadoPan
questGroups["ShieldWall"]=shieldWall


function SJ:CreateTrackingFrame()
    self.sjquestFrame = CreateFrame("Frame","sjquestFrame",UIParent)
	self.sjquestFrame:SetMovable(true)
	self.sjquestFrame:EnableMouse(true)
	self.sjquestFrame:SetClampedToScreen(true)
	self.sjquestFrame:RegisterForDrag("LeftButton")
	self.sjquestFrame:SetScript("OnDragStart", function(frame)
	--	if not SJ.db.global.locked then 
			frame:StartMoving() 
	--	end
	end)
	self.sjquestFrame:SetScript("OnDragStop", function(frame)
			frame:StopMovingOrSizing()
	--		SJ.db.global.framePosition.anchor, _, _, SJ.db.global.framePosition.x, SJ.db.global.framePosition.y = frame:GetPoint()
	end)
	self.sjquestFrame:SetBackdropColor(0,0,0,1);
	self.sjquestFrame:SetHeight(200)
	self.sjquestFrame:SetWidth(200)
	self.sjquestFrame:SetAlpha(1.0)
	
	-- Create empty array to store quests
	self.sjquestFrame.quests = {}
	
	-- Vertical offset to keep track of position of new text lines
	local offset = 0
	
	-- Create the title text
	local title = self.sjquestFrame:CreateFontString("TitleText", nil, "GameFontNormalLarge")
	title:SetText("|cffFFB90FSecondJob|r")
	title:SetPoint("TOPLEFT", self.sjquestFrame, "TOPLEFT", -4, -offset)
	title:Show()
	
	-- Adjust offset for beginning of list
	offset = offset + 18
	local completedQuests= GetQuestsCompleted(questTbl)
	-- Create quest tracking frame contents
	for questId, quest in pairs(questGroups["Weeklies"]) do
		self:CreateQuestInSJquestFrame(quest,questId, offset,completedQuests)
		offset = offset + 16
	end
	offset=offset+8
	for questId, quest in pairs(questGroups["Dailies"]) do
		self:CreateQuestInSJquestFrame(quest,questId, offset,completedQuests)
		offset = offset + 16
	end
	--golden lotus
		self:CreateQuestInSJquestFrame("GoldenLotus",1, offset,completedQuests)
		offset = offset + 16
		--sp
	self:CreateQuestInSJquestFrame("ShadoPan",2, offset,completedQuests)
		offset = offset + 16
	--ac
	self:CreateQuestInSJquestFrame("AugustCelestials",3, offset,completedQuests)
		offset = offset + 16
	self.sjquestFrame:SetHeight(32)
	self.sjquestFrame:SetPoint("TOPLEFT", 5, 15)
	--sw
	self:CreateQuestInSJquestFrame("ShieldWall",4, offset,completedQuests)
		offset = offset + 16
	self.sjquestFrame:SetHeight(32)
	self.sjquestFrame:SetPoint("TOPLEFT", 5, 15)
end

function SJ:CreateQuestInSJquestFrame(questTitle, questId, offset)
	self.sjquestFrame.quests[questId] = {}
	local mytext=SJ:getQuestInfo(questTitle,questId)
	self.sjquestFrame.quests[questId].headerText = self.sjquestFrame:CreateFontString("QuestHeader"..questId, nil, "ChatFontNormal")
	self.sjquestFrame.quests[questId].headerText:SetText(mytext)
	self.sjquestFrame.quests[questId].headerText:SetPoint("TOPLEFT", self.sjquestFrame, "TOPLEFT", 16, -offset)
	self.sjquestFrame.quests[questId].headerText:Show()
	
end

function SJ:getQuestInfo(questTitle, questId)
	
	local completed="|cFFFF0000N|r"
	if questTitle=="GoldenLotus" then
		local gl="|cFFFF0000N|r"
		for questId, quest in pairs(questGroups["GoldenLotus"]) do
			if completedQuests[questId] then
				gl="|cFF00FF00Y|r"
			end
		end
		completed=gl
	end

	if questTitle=="ShadoPan" then
		if debug then DEFAULT_CHAT_FRAME:AddMessage("refreshing sp") end
		local sp="|cFFFF0000N|r"
		for questId, quest in pairs(questGroups["ShadoPan"]) do
			if completedQuests[questId] then
				sp="|cFF00FF00Y|r"
				if debug then DEFAULT_CHAT_FRAME:AddMessage("sp yes") end
			end
		end
		completed=sp
		if debug then DEFAULT_CHAT_FRAME:AddMessage("sp: "..completed) end
	end

	if questTitle=="AugustCelestials" then
		local ac="|cFFFF0000N|r"
		--group 1 2 stages, i think you can just check for stage 2:
		for questId, quest in pairs(questGroups["AugustCelestials"][1]) do
			if completedQuests[questId] then
				ac="|cFF00FF00Y|r"
			end
		end
		--group 2
		for questId, quest in pairs(questGroups["AugustCelestials"][2]) do
			if completedQuests[questId] then
				ac="|cFF00FF00Y|r"
			end
		end
		--group 3
		if (completedQuests[30956] and completedQuests[30957] and completedQuests[30958] and completedQuests[30959]) or(completedQuests[30952] and completedQuests[30953] and completedQuests[30954] and completedQuests[30955] ) then
			ac="|cFF00FF00Y|r"
		end
		--group 4
		if (completedQuests[31517] and completedQuests[31380]) or(completedQuests[30907] and completedQuests[31380]) then
			ac="|cFF00FF00Y|r"
		end
		completed=ac
	end
	--
	if questTitle=="ShieldWall" then
		if debug then DEFAULT_CHAT_FRAME:AddMessage("refreshing sw") end
		local sw="|cFFFF0000N|r"
		--local sw="|cFF00FF00Y|r"
	--[[	for i=1, table.getn(questGroups["ShieldWall"]), 1 do
			sw="|cFF00FF00Y|r"
			for questId, quest in pairs(questGroups["ShieldWall"][i]) do
				if not completedQuests[questId] then
					sw="|cFFFF0000N|r"
					break
				end
				
			end
			if debug then DEFAULT_CHAT_FRAME:AddMessage("sw: "..i.." "..sw) end
			if sw=="Y" then
				break
			end	
			
		end
		--]]

		--Hub 1 (Bilgewater Beach)
		if (completedQuests[32157] and completedQuests[32156] and (completedQuests[32158]  or completedQuests[32433]) and (completedQuests[32154]  or completedQuests[32155]) and (completedQuests[32446]  or completedQuests[32159])) then
			sw="|cFF00FF00Y|r"
		end
		--Hub 2 (Domination Point)
		if (completedQuests[32146] and completedQuests[32144] and completedQuests[32142] and completedQuests[32143] and completedQuests[32145]) then
			sw="|cFF00FF00Y|r"
		end
		--Hub 3 (Lion's Landing)
		if (completedQuests[32148] and completedQuests[32153] and completedQuests[32149] and completedQuests[32150] and (completedQuests[32152]  or completedQuests[32151] )) then
			sw="|cFF00FF00Y|r"
		end
		--Hub 4 (Ruins of Ogudei)
		if (completedQuests[32121] and completedQuests[32347] and completedQuests[32346] and completedQuests[32122] and (completedQuests[32119]  or completedQuests[32115] )) then
			sw="|cFF00FF00Y|r"
		end
		
		completed=sw
		if debug then DEFAULT_CHAT_FRAME:AddMessage("sw: "..completed) end
	end
	
--	]]
	if questId==32016 then
		name, currentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered = GetCurrencyInfo(738)
		completed = "|cFFFF0000N ("..currentAmount..")|r"
	end

	if completedQuests[questId] then
		completed="|cFF00FF00Y|r"
	end
	
	return questTitle.." "..completed
end

function SJ:updateQuest(questTitle,questId)
	local mytext=SJ:getQuestInfo(questTitle,questId)
	if debug then DEFAULT_CHAT_FRAME:AddMessage(questTitle .. " " .. mytext) end
	self.sjquestFrame.quests[questId].headerText:SetText(mytext)
end

function SJ:toggleFrame()
	if not self.sjquestFrame:IsShown() then
		self.sjquestFrame:Show()
	else
		self.sjquestFrame:Hide()
	end
end

function SJ:toggleDebug()
	if debug then
		debug=false
		DEFAULT_CHAT_FRAME:AddMessage("Debug disabled")
	else
		debug=true
		DEFAULT_CHAT_FRAME:AddMessage("Debug enabled!")
	end
end


function SJ:OnInitialize()
	RegisterAddonMessagePrefix(PREFIX)
	SJ:RegisterChatCommand("sj_toggle", "toggleFrame")
	SJ:RegisterChatCommand("sj_toggle_debug", "toggleDebug")
	SJ:RegisterChatCommand("sj_refresh", "Refresh")
	SJ:RegisterChatCommand("sj_version", "version")
	self:CreateTrackingFrame()
end

function SJ:OnEnable()
	self:Print("Addon SecondJob enabled.  Use '/sj_toggle' to show/hide")

end

function SJ:version()
	self:Print("Version:"..VERSION)

end

function SJ:Test()
	local j=1
	--for i=1,GetNumTradeSkills() do
	for i=GetNumTradeSkills(), 1, -1 do
	--for i=1,100 do
		local cooldown = GetTradeSkillCooldown(i)
		local name = GetTradeSkillInfo(i)
		if name=="Sha Crystal" then
	
			print("sha crystal"..cooldown)
		end
		if name=="Scroll of Wisdom" then
	
			print("Scroll of Wisdom"..cooldown)
		end

	--	if cooldown then
        
	--	   print("Cooldown remaining for " .. name .. "("..i.."): " .. SecondsToTime(cooldown))
	--	print(name)
	--	end
		j=j+1
	end
	prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions()
	print("prof1: "..GetProfessionInfo(prof1))
	print("prof2: "..GetProfessionInfo(prof2))

	print (j.." total")
end


local frame, events = CreateFrame("Frame"), {};
function events:QUEST_FINISHED(...)
if debug then DEFAULT_CHAT_FRAME:AddMessage("Event QUEST_FINISHED Fired!") end
SJ:Refresh()
end
function events:QUEST_LOG_UPDATE(...)
if debug then DEFAULT_CHAT_FRAME:AddMessage("Event QUEST_LOG_UPDATE Fired") end
SJ:Refresh()
end
frame:SetScript("OnEvent", function(self, event, ...)
 events[event](self, ...); -- call one of the functions above
end);
for k, v in pairs(events) do
 frame:RegisterEvent(k); -- Register all events for which handlers have been defined
end

total=0

function SJ:Refresh()
 if debug then DEFAULT_CHAT_FRAME:AddMessage("Start refresh!") end
		completedQuests= GetQuestsCompleted()
		for questId, quest in pairs(questGroups["Weeklies"]) do
			SJ:updateQuest(quest,questId)
		end
		for questId, quest in pairs(questGroups["Dailies"]) do
			SJ:updateQuest(quest,questId)
		end
		SJ:updateQuest("GoldenLotus",1)
		SJ:updateQuest("ShadoPan",2)
		SJ:updateQuest("AugustCelestials",3)
		SJ:updateQuest("ShieldWall",4)
		--	SJ:Test()
		if debug then DEFAULT_CHAT_FRAME:AddMessage("Finished refresh!") end
        total = 0
		--table.wipe(completedQuests)
		for k,v in pairs(completedQuests) do
		  completedQuests[k] = nil
		end
end

local function onUpdate(self,elapsed)
    total = total + elapsed
    if total >= 30 then
       if debug then DEFAULT_CHAT_FRAME:AddMessage("Start refresh!") end
		completedQuests= GetQuestsCompleted()
		for questId, quest in pairs(questGroups["Weeklies"]) do
			SJ:updateQuest(quest,questId)
		end
		for questId, quest in pairs(questGroups["Dailies"]) do
			SJ:updateQuest(quest,questId)
		end
		SJ:updateQuest("GoldenLotus",1)
		SJ:updateQuest("ShadoPan",2)
		SJ:updateQuest("AugustCelestials",3)
		SJ:updateQuest("ShieldWall",4)
		----	SJ:Test()
		if debug then DEFAULT_CHAT_FRAME:AddMessage("Finished refresh!") end
        total = 0
		--table.wipe(completedQuests)
		for k,v in pairs(completedQuests) do
		  completedQuests[k] = nil
		end
    end
end
local f = CreateFrame("frame")
f:SetScript("OnUpdate", onUpdate)